#! /usr/bin/env python
# Semplice scritp di correzione del SID Samba su LDAP
#
# Copyright (C) 2005 Simone Piccardi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import ldap
from os import *
import re

try: 
    l = ldap.open("127.0.0.1")
    l.protocol_version = ldap.VERSION3
    username = "cn=admin,dc=scuola,dc=local"
    password = "pippo"
    l.simple_bind(username, password)

except ldap.LDAPError, e:
    print "Connection error", e

baseDN = "dc=scuola,dc=local"
searchScope = ldap.SCOPE_SUBTREE
searchFilter = "(|(sambaSID=*)(sambaPrimaryGroupSID=*))"
retrieveAttributes = ["sambaSID", "sambaPrimaryGroupSID"]

try:
    ldap_result_id = l.search(baseDN, searchScope, searchFilter, retrieveAttributes)
    result_set = []
    count = 0
    while 1:
	result_type, result_data = l.result(ldap_result_id, 0)
	if (result_data == []):
	    break
	else:
	    if result_type == ldap.RES_SEARCH_ENTRY:
		result_set.append(result_data)
#    print result_set
except ldap.LDAPError, e:
    print "Search error", e
    
if len(result_set) == 0:
    print "No Results"
    exit

    
for i in range(len(result_set)):
    for voce in result_set[i]:
	#print voce[1]
	dn        = voce[0]
	sid       = voce[1]['sambaSID'][0]
	#print sid # stampa tutti i SID 
#  
# Correzione del SID
#
	if (re.match(r' (\S*)',sid)):
	    print "Correggo",dn 
	    print "-",sid
	    corr = re.sub(r' (\S*)',r'\1',sid)
	    print "+",corr
	    l.modify_s(dn,[(ldap.MOD_REPLACE,'sambaSID',corr)])

#  
# Correzione del sambaPrimaryGroupSID
#
	try:
	    groupsid = voce[1]['sambaPrimaryGroupSID'][0]
	    if (re.match(r' (\S*)',groupsid)):
		#print "Correggo",dn 
		print "-",groupsid
		corr = re.sub(r' (\S*)',r'\1',groupsid)
		print "+",corr
		l.modify_s(dn,[(ldap.MOD_REPLACE,'sambaPrimaryGroupSID',corr)])	
	except KeyError, e:
	    print "no sambaPrimaryGroupSID"
